#ifndef DATABASE_H_SEEN
#define DATABASE_H_SEEN




#include "database/song_collection.h"
#include "database/song_set.h"
#include "database/song_set_tree.h"
#include "database/history.h"




class tProgress;




class tDatabase 
{
  public:
    tDirectoryList DirectoryList;
    tSongCollection SongCollection;
    tSongSetNode *SongSetTree;
    tHistory History;

    tDatabase();
    ~tDatabase();
    void clear();
    void startNew();
    void load( const QString &filename, tProgress *progress = NULL );
    void save( const QString &filename, tProgress *progress = NULL );

  private:
    // make this type noncopyable
    tDatabase( const tDatabase &src );
    tDatabase &operator=( const tDatabase &src );
};




#endif
