#include "history.h"
#include "database/song.h"




void tHistory::played( tUniqueId id, time_t when, double duration )
{
  tHistoryEntry entry;
  entry.UniqueId = id;
  entry.Time = when;
  entry.PlayDuration = duration;
  HistoryList.push_back( entry );
}




void tHistory::clear()
{
  HistoryList.clear();
}




QDomNode tHistory::serialize( QDomDocument &doc )
{
  QDomElement history = doc.createElement( "history" );
  FOREACH_CONST( first, HistoryList, tHistoryList )
  {
    QDomElement entry = doc.createElement( "playedsong" );
    entry.setAttribute( "uniqueid", first->UniqueId );
    entry.setAttribute( "time", (int) first->Time );
    entry.setAttribute( "playduration", first->PlayDuration );

    history.appendChild( entry );
  }
  return history;
}
