#ifndef SONG_SET_TREE
#define SONG_SET_TREE




#include "song_set.h"




class tSongSetNode
{
    QString Name;
    tSongSetNode *Parent;
    typedef vector<tSongSetNode *> tChildrenList;
    tChildrenList ChildrenList;
    tSongSet *Data;

  public:
    typedef tChildrenList::iterator iterator;

    tSongSetNode( tSongSet *data );
    ~tSongSetNode();

    iterator begin()
    {
      return ChildrenList.begin();
    }
    iterator end()
    {
      return ChildrenList.end();
    }

    tSongSetNode *parent();
    void addChild( tSongSetNode *node );
    void insertChild( tSongSetNode *node, iterator it );
    void removeChild( tSongSetNode *node );
    void clear();

    QString qualifiedName();
    tSongSetNode *resolve( const QString &name );
    bool hasParent( tSongSetNode *node );

    QString const &name();
    void setName( QString const &name );
    tSongSet *data();
    void setData( tSongSet *data );

    QDomNode serialize( QDomDocument &doc );
    
  private:
    // make this type noncopyable
    tSongSetNode( const tSongSetNode &src );
    tSongSetNode &operator=( const tSongSetNode &src );
};




#endif
