#include <exception>
#include <qapplication.h>
#include <qtextcodec.h>
#include "utility/player.h"
#include "database/database.h"
#include "ui/mainwin.h"




int main( int argc, char **argv )
{
  srand( time( NULL ) );

  try
  {
    if ( argc == 2 && strcmp( argv[1], "--play-random" ) == 0 )
    {
      QApplication app( argc, argv, /* GUIEnabled */ false );

      QTranslator translator( 0 );
      translator.load( QString("madman_") + QTextCodec::locale(), "." );
      app.installTranslator( &translator );

      cout << "playing 20 random songs... wait..." << endl;

      QSettings settings;
      tPreferences prefs;
      prefs.load( settings );

      tDatabase database;
      bool filename_valid = false;
      QString filename = settings.readEntry( "/madman/startup_file", QString::null, &filename_valid  );
      if ( !filename_valid )
	return 1;
      database.load( filename, NULL );
      
      int const song_count = 20;

      tSongList songs,rendering;
      FOREACH_CONST( first, database.SongCollection, tSongCollection )
	rendering.push_back( *first );

      for ( int i = 0; i < song_count; i++ )
      {
	int index = rand() % rendering.size();
	songs.push_back( rendering[ index ] );
      }

      if ( prefs.Player )
	prefs.Player->playEventually( songs );
    }
    else
    {
      QApplication app( argc, argv );

      QTranslator translator( 0 );
      translator.load( QString("madman_") + QTextCodec::locale(), "." );
      app.installTranslator( &translator );

      tMainWindow mwin;
      mwin.show();
      app.setMainWidget( &mwin );
      return app.exec();
    }
  }
  catch ( exception & ex )
  {
    cerr << "*** terminated by fatal exception:" << endl;
    cerr << "*** " << ex.what() << endl;
  }
}
