#include "accel_list_view.h"
#include "utility/base.h"

#include "accel_list_view.moc"




tKeyboardShortCut::tKeyboardShortCut( const QKeySequence &keys )
  : Keys( keys )
{
}




tKeyboardShortCut::tKeyboardShortCut( const QKeySequence &keys, QObject *o, const char *slot )
  : Keys( keys )
{
  connect( this, SIGNAL(triggered()), o, slot );
}




bool tKeyboardShortCut::processKeyEvent( QKeyEvent *e )
{
  int accel_state = 0;
  if ( e->state() & ShiftButton )
    accel_state |= SHIFT;
  if ( e->state() & ControlButton )
    accel_state |= CTRL;
  if ( e->state() & MetaButton )
    accel_state |= META;
  if ( e->state() & AltButton )
    accel_state |= ALT;

  if ( QKeySequence( accel_state | e->key() ) == Keys )
  {
    emit triggered();
    return true;
  }
  else
    return false;
}




// tAcceleratorListView -------------------------------------------------------
tAcceleratorListView::tAcceleratorListView( QWidget *parent, const char *name, WFlags f )
  : super( parent, name, f )
{
}




tAcceleratorListView::~tAcceleratorListView()
{
  FOREACH( first, KeysList, tKeysList )
    delete *first;
}




void tAcceleratorListView::addShortCut( tKeyboardShortCut *sc )
{
  KeysList.push_back( sc );
}





void tAcceleratorListView::keyPressEvent ( QKeyEvent * e )
{
  if ( hasFocus() )
  {
    FOREACH( first, KeysList, tKeysList )
      if ( (*first)->processKeyEvent( e ) )
	return;
  }

  super::keyPressEvent( e );
}
