#ifndef ACCEL_LIST_VIEW_H_SEEN
#define ACCEL_LIST_VIEW_H_SEEN




#include <qkeysequence.h>
#include <qlistview.h>
#include <vector>
#include "utility/base.h"




class tKeyboardShortCut : public QObject
{
    Q_OBJECT
    QKeySequence	Keys;

  public:
    tKeyboardShortCut() 
    { }
    tKeyboardShortCut( const QKeySequence &keys );
    tKeyboardShortCut( const QKeySequence &keys, QObject *o, const char *slot );
    bool processKeyEvent( QKeyEvent *e );

  signals:
    void triggered();
};




class tAcceleratorListView : public QListView
{
    typedef QListView			super;
    typedef vector<tKeyboardShortCut *>	tKeysList;
    tKeysList				KeysList;

  public:
    tAcceleratorListView( QWidget *parent = 0, const char *name = "", WFlags f = 0 );
    ~tAcceleratorListView();

    void addShortCut( tKeyboardShortCut *sc );
    void keyPressEvent ( QKeyEvent * e );
};




#endif
