#include <qlistbox.h>
#include <qpushbutton.h>
#include <qfiledialog.h>

#include "dirlist.h"

#include "dirlist.moc"




// tDirectoryListManager ------------------------------------------------------
tDirectoryListManager::tDirectoryListManager( QWidget *parent, tDirectoryList &dir_list,
    QListBox *lstbox,
    QPushButton *add_button,
    QPushButton *remove_button )
: Parent( parent ), DirectoryList( dir_list ), ListBox( lstbox ),
AddButton( add_button ),RemoveButton( remove_button )
{
  update();
  connect( AddButton, SIGNAL( clicked() ), this, SLOT( add() ) );
  connect( RemoveButton, SIGNAL( clicked() ), this, SLOT( remove() ) );
}




tDirectoryList &tDirectoryListManager::directoryList()
{
  return DirectoryList;
}




void tDirectoryListManager::add()
{
  QString dir = QFileDialog::getExistingDirectory( QString::null, Parent, tr( "Add Directory" ) );
  if ( dir == QString::null )
    return;
  DirectoryList.push_back( dir );
  update();

  emit changed();
}




void tDirectoryListManager::remove()
{
  DirectoryList.erase( DirectoryList.begin( ) + ListBox->currentItem( ) );
  update();

  emit changed();
}




void tDirectoryListManager::update()
{
  ListBox->clear();
  FOREACH_CONST( first, DirectoryList, tDirectoryList )
    ListBox->insertItem( *first );
}





