#ifndef HEADER_SEEN_OVERVIEW_H
#define HEADER_SEEN_OVERVIEW_H




#include "utility/base.h"
#include <qlistview.h>




class tDatabase;




class tOverviewItem : public QListViewItem
{
    QString Criterion;

  public:
    tOverviewItem( QListView *view,  QListViewItem *after, const QString &label, const QString &criterion );
    tOverviewItem( QListViewItem *parent, QListViewItem *after, const QString &label, const QString &criterion );
    const QString &criterion() const
    { return Criterion; }
};

class tExpandableOverviewItem : public tOverviewItem
{
    bool HasExpanded;
    
  public:
    tExpandableOverviewItem( QListView *view,  QListViewItem *after, const QString &label, const QString &criterion );
    tExpandableOverviewItem( QListViewItem *parent, QListViewItem *after, const QString &label, const QString &criterion );
    void setOpen( bool o );
    virtual void addExpansion();
};

class tArtistsOverviewItem : public tExpandableOverviewItem
{
    tDatabase	&Database;
  public:
    tArtistsOverviewItem( tDatabase &database, QListView *view,  QListViewItem *after, const QString &label, const QString &criterion );
    tArtistsOverviewItem( tDatabase &database, QListViewItem *parent, QListViewItem *after, const QString &label, const QString &criterion );
    void addExpansion();
};

class tAlbumOverviewItem : public tExpandableOverviewItem
{
    tDatabase	&Database;
  public:
    tAlbumOverviewItem( tDatabase &database, QListView *view,  QListViewItem *after, const QString &label, const QString &criterion );
    tAlbumOverviewItem( tDatabase &database, QListViewItem *parent, QListViewItem *after, const QString &label, const QString &criterion );
    void addExpansion();
};

class tGenreOverviewItem : public tExpandableOverviewItem
{
    tDatabase	&Database;
  public:
    tGenreOverviewItem( tDatabase &database, QListView *view,  QListViewItem *after, const QString &label, const QString &criterion );
    tGenreOverviewItem( tDatabase &database, QListViewItem *parent, QListViewItem *after, const QString &label, const QString &criterion );
    void addExpansion();
};


#endif
