#ifndef HEADER_SEEN_PREFS_H
#define HEADER_SEEN_PREFS_H




#include <vector>
#include "utility/base.h"
#include "designer/prefs_ui.h"
#include "ui/dirlist.h"




class tPlayer;
class tMainWindow;
class QSettings;




struct tPreferences
{
  bool RememberGeometry;
  bool ScanAtStartup;
  bool CollectHistory;
  bool UseFuzzySearch;

  int BackupCount;

  tPlayer *Player;
  tDirectoryList PluginDirectories;

  vector<bool> ColumnVisibility;

  tPreferences()
  {
    Player = NULL;
  }

  void save( QSettings &settings );
  void load( QSettings &settings );

  void setPlayer( tPlayer *newplayer );
};




class tPreferencesDialog : public tPreferencesDialogBase
{
    Q_OBJECT;

    tFilename SelectedPlugin;

  public:
    tDirectoryListManager 	MediaDirectoryListManager;
    tDirectoryListManager	PluginDirectoryListManager;
    QSettings			&Settings;

  public:
    tPreferencesDialog( QWidget* parent, tDirectoryList &media_dir_list, 
	tDirectoryList &plugin_dir_list, QSettings &settings );

  public slots:
    void updatePluginList();
    void updateSelectedPluginInfo( int index );
    void configurePlugin();
};




bool editPreferences( tMainWindow *mainwin, tPreferences &prefs, 
    tDirectoryList &media_dir_list, QSettings &settings, int starting_tab = 0 );




#endif
