#ifndef BASE
#define BASE




#include <iostream>
#include <string>
#include <qstring.h>
#include <qstringlist.h>
#include <qobject.h>
#include <qdatetime.h>

#include <vector>
#if __GNUC__ >= 3 
#include <ext/hash_map>
#include <ext/hash_set>
#else
#include <hash_map>
#include <hash_set>
#endif

#include "config.h"




using namespace std;
#if __GNUC__ >= 3 
using __gnu_cxx::hash_map;
using __gnu_cxx::hash_set;
#endif



#define MADMAN_VERSION		VERSION




class tSong;




typedef int tUniqueId;
typedef unsigned tIndex;
typedef QString tFilename;
typedef vector<tFilename> tDirectoryList;
typedef vector<tSong *> tSongList;
typedef vector<tUniqueId> tUniqueIdList;
typedef hash_set<tUniqueId> tUniqueIdSet;








#define FOREACH(VAR,LIST,LISTTYPE) \
  for (LISTTYPE::iterator VAR = (LIST).begin(),last = (LIST).end();VAR != last;VAR++)
#define FOREACH_CONST(VAR,LIST,LISTTYPE) \
  for (LISTTYPE::const_iterator VAR = (LIST).begin(),last = (LIST).end();VAR != last;VAR++)




bool hasAttribute( const char *name, const char **attributes );
QString lookupAttribute( const char *name, const char **attributes );

string QString2string( QString const &str );
QString string2QString( string const &str );
QString wstring2QString( const wchar_t *str );
vector<QString> QStringList2QStringvector( const QStringList &strlist );
QStringList QStringvector2QStringList( const vector<QString> &strlist );
ostream &operator <<( ostream &ostr, QString const &str );
void runtimeError( QString const &str );



class hash_QString
{
  public:
    unsigned long operator() ( QString const &str ) const;
};

class tProfiler
{
    QTime		Time;
    QString	Name;

  public:
    tProfiler( const QString &name = "" );
    ~tProfiler();
};



#endif
