#include <stdexcept>
#include "base.h"
#include "scanner.h"




void tScanner::addTokenDescriptor( int type, const QString &pattern, bool minimal, bool ignore )
{
  tTokenDescriptor d;
  d.TokenType = type;
  d.RegExp = "^"+pattern;
  d.RegExp.setMinimal( minimal );
  d.Ignore = ignore;
  TokenDescriptorList.push_back( d );
}




void tScanner::scan( const QString &victim, tTokenList &tokenlist )
{
  int index = 0;

  tokenlist.clear();
  while ( index < (int) victim.length() )
  {
    bool found_a_token = false;
    FOREACH_CONST( first, TokenDescriptorList, tTokenDescriptorList )
    {
      if ( first->RegExp.search( victim.mid( index ) ) != -1 )
      {
	if ( !first->Ignore )
	{
	  tToken token;
	  token.TokenType = first->TokenType;
	  token.Text = victim.mid( index, first->RegExp.matchedLength() );
	  tokenlist.push_back( token );
	}
	index += first->RegExp.matchedLength();
	found_a_token = first->RegExp.matchedLength() > 0;
	if ( found_a_token )
	  break;
      }
    }

    if (!found_a_token)
      throw runtime_error( "invalid token at: " + QString2string( victim.mid( index, 20 ) ) );
  }
}

